From 302e45d1b2e7f08a0e05f05fa0a3603d47307d83 Mon Sep 17 00:00:00 2001
From: Paolo Valente <paolo.valente@unimore.it>
Date: Mon, 20 Jul 2015 01:43:06 +0200
Subject: [PATCH] block: Switch from BFQ-v7r8 for 4.2.0 to BFQ-v7r9 for 4.2.0

. IMPROVEMENT: Changed BFQ to use the blkio controller instead of its
  own controller. BFQ now registers itself as a policy to the blkio
  controller and implements its hierarchical scheduling support using
  data structures that already exist in blk-cgroup.  The bfqio
  controller's code is completely removed.

. CODE IMPROVEMENTS: Applied all suggestions from Tejun Heo, received
  on the last submission to lkml: https://lkml.org/lkml/2014/5/27/314.

Signed-off-by: Paolo Valente <paolo.valente@unimore.it>
Signed-off-by: Arianna Avanzini <avanzini@google.com>
---
 block/Kconfig.iosched         |    6 +-
 block/bfq-cgroup.c            | 1282 +++++++++++++++++++++++------------------
 block/bfq-ioc.c               |    6 +-
 block/bfq-iosched.c           | 1083 ++++++++++++++++++++--------------
 block/bfq-sched.c             |  209 ++++---
 block/bfq.h                   |  206 ++++---
 include/linux/blkdev.h        |    2 +-
 include/linux/cgroup_subsys.h |    4 -
 8 files changed, 1621 insertions(+), 1177 deletions(-)

diff --git a/block/Kconfig.iosched b/block/Kconfig.iosched
index 0ee5f0f..f78cd1a 100644
--- a/block/Kconfig.iosched
+++ b/block/Kconfig.iosched
@@ -51,14 +51,12 @@ config IOSCHED_BFQ
 	  applications. If compiled built-in (saying Y here), BFQ can
 	  be configured to support hierarchical scheduling.
 
-config CGROUP_BFQIO
+config BFQ_GROUP_IOSCHED
 	bool "BFQ hierarchical scheduling support"
 	depends on CGROUPS && IOSCHED_BFQ=y
 	default n
 	---help---
-	  Enable hierarchical scheduling in BFQ, using the cgroups
-	  filesystem interface.  The name of the subsystem will be
-	  bfqio.
+	  Enable hierarchical scheduling in BFQ, using the blkio controller.
 
 choice
 	prompt "Default I/O scheduler"
